/* Global variables */
var popoutMenu=0;
var expandedCourses=0;

/* Functions */
$(document).ready(function(){
	$('#expandedCourses').hide();
	$('#popoutMenu').hide();
	$('#passwordChanger').hide();


	/* Check courses in expanded menu */
	$('li[class="expanded"]').click(function(){
		if($(this).hasClass('checkedCourse')){
			$(this).removeClass('checkedCourse');
		}
		else{
			$(this).addClass("checkedCourse");
		}
	});

	/* Blurs body and opens password changer */
	$('li[name="changePwd"]').click(function(e){
		e.stopPropagation();
		$('#popoutMenu').stop(false, false).slideUp(300);
		popoutMenu=0;
	    $('body *').not('#passwordChanger, #passwordChanger *').animate({
		opacity:0.4}, 400);
		$('#passwordChanger').fadeIn(300);
		$('#passwordChanger').css('z-index', 3000);
	});
	
	$('body').click(function(e){
		$('#formContainer').fadeOut(300);
		$('#passwordChanger').fadeOut(300);
		$('body *').animate({
		opacity:1}, 400);
		$('#changePassword')[0].reset();
	});
	
	$('#passwordChanger').click(function(e){
		e.stopPropagation();
	});
	
	$('#formContainer').click(function(e){
		e.stopPropagation();
	});
	
	$('#popoutLink').click(function(e){
		if(popoutMenu==0){
			$('#popoutMenu').stop(false, true).slideDown(300);
			popoutMenu=1;
			e.stopPropagation();
		// FIXA SÅ MENYN INTE KOMMER UPP IGEN
		}
		else if(popoutMenu==1){
			$('#popoutMenu').stop(false, false).slideUp(300);	
			popoutMenu=0;
			e.stopPropagation();
		}
	});
	
	$('#loginLink').click(function(e){
		var target = $('#formContainer');
		if(target.is(":hidden")){
			target.fadeIn(300);
			$('#username').focus();
			e.stopPropagation();
		}
		else{
			target.fadeOut(300);
		}
		
	});
});

window.onkeyup = function(event){
	if(event.keyCode==27){
		$('#formContainer').fadeOut(300);
		$('#passwordChanger').fadeOut(300);
		$('body *').animate({
		opacity:1}, 400);
		$('#changePassword')[0].reset();
	}
}

/* Closing password changer and reactivates body */
function cancelPasswordChange(){
	$('#passwordChanger').fadeOut(300);
	$('body *').animate({
	opacity:1}, 400);
	$('#changePassword')[0].reset();
}


/* Expand/Collapse courses in popout menu */
function expandCourses(){
	if(expandedCourses==0){
	$('#expandedCourses').stop(false, true).slideDown(300);
	expandedCourses=1;
	}
	else if(expandedCourses==1){
		$('#expandedCourses').stop(false, false).slideUp(300);	
		expandedCourses=0;
	}
}



/* Password validation */
var acceptedNewPwd = false;
var acceptedRepeatedPwd = false;

function emptyField(inputId){
	var id = document.getElementById(inputId);
	if(id.value.match(/^\s*$/)){
		return true;
	}
	else return false;
}

/* Checks input field for invalid characters */
function pwdValidCharacters(inputId){
	var id = document.getElementById(inputId);
	if(id.value.match(/^[A-Ã–a-Ã¶0-9 _]*[A-Ã–a-Ã¶0-9][A-Ã–a-Ã¶0-9 _]*$/)){
		return true;
	}
	else return false;
}

/* Checks input field for minimum amount of characters(6) */
function pwdMininumValue(inputId){
	var id = document.getElementById(inputId);
	if(id.value.length > 5){
		return true;
	}
	else return false;
}

/* Checks if newPwd and repeatPwd are the same */
function pwdMatch(){
	var firstPwd = document.getElementById("newPwd").value;
	var secondPwd = document.getElementById("repeatPwd").value;
	if(firstPwd == secondPwd){
		return true;
	}
	else return false;
}

function validNewPwd(){
	var empty = emptyField("newPwd");
	var validchar = pwdValidCharacters("newPwd");
	var minimumchar = pwdMininumValue("newPwd");

	if (empty==false && validchar==true && minimumchar==true){
		document.getElementById("newPwd").className="Valid";
		$('.errorMessage[name="newPwd"]').animate({opacity:0}, 0);
		acceptedNewPwd=true;
	}
	else if(empty==true){
		acceptedNewPwd=false;
		document.getElementById("newPwd").className="";
		$('.errorMessage[name="newPwd"]').animate({opacity:0}, 0);
	}
	else if(empty==false && validchar==false || minimumchar==false){
		document.getElementById("newPwd").className="notValid";
		$('.errorMessage[name="newPwd"]').animate({opacity:1}, 0);
		acceptedNewPwd=false;
	}
}

function validRepeatedPwd(){
	var empty = emptyField("repeatPwd");
	var match = pwdMatch("repeatPwd");
	
	if(validNewPwd){
		if(empty==true){
			document.getElementById("repeatPwd").className="";
			$('.errorMessage[name="repeatPwd"]').animate({opacity:0}, 0);
			acceptedRepeatedPwd=false;
		}
		else if(empty==false && match==false){
			document.getElementById("repeatPwd").className="notValid";
			$('.errorMessage[name="repeatPwd"]').animate({opacity:1}, 0);
			acceptedRepeatedPwd=false;
		}
		else if(empty==false && match==true){
			document.getElementById("repeatPwd").className="Valid";
			$('.errorMessage[name="repeatPwd"]').animate({opacity:0}, 0);
			acceptedRepeatedPwd=true;
		}
	}
	else{
		document.getElementById("repeatPwd").className="";
	}
}

/* baseURL skickas med som parameter */
function confirm(baseURL){
	if(acceptedNewPwd && acceptedRepeatedPwd){
		changePwd(baseURL);
	}
	else{
		alert("WRONG WRONG WRONG!! FILL OUT THE FORM AGAIN YOU FKIN PIECE OF SHIT!");
		return false;
	}
}

function changePwd(baseURL)
{
	var currentPwd = document.getElementById("currentPwd").value;
	var newPwd = document.getElementById("newPwd").value;
	var hintPwd = document.getElementById("hintPwd").value;

	$.ajax({
		type: 'POST',
		url: baseURL+'ajax/pwdchange',
		data: { 
			currentPwd : currentPwd,
			newPwd : newPwd,
			hintPwd : hintPwd
		},
		success:  function(result){
			var resultObject = JSON.parse(result);
			if(resultObject.status==true){
				alert('Password change is successful!');
				$('#formContainer').fadeOut(300);
				$('#passwordChanger').fadeOut(300);
				$('body *').animate({
				opacity:1}, 400);
				$('#changePassword')[0].reset();
			}
			else{
				alert('Wrong password!');
			}
		}
	});
}